Jump Game (LeetCode 55) | Full solution with animations and visuals | Greedy Algorithms

Поделиться
HTML-код
  • Опубликовано: 1 дек 2024

Комментарии • 103

  • @namanpande7644
    @namanpande7644 11 месяцев назад +7

    This is actually a very good explanation. I was able to understand because of the dry-run of the code. Thanks a lot.

  • @meghan6819
    @meghan6819 9 месяцев назад +4

    Your solutions and explanations are great!! thank you

  • @shwetakumari-ms2xg
    @shwetakumari-ms2xg Год назад +2

    watching your video for the first time, really liked your explanation. Would watch more of your videos :) thanks!

    • @nikoo28
      @nikoo28  Год назад

      Glad you like them!

  • @yomamasofat413
    @yomamasofat413 3 месяца назад +2

    man every question like this just feels so exhausting. It's either some kind of trick or hack to solve the problem.

  • @arupgope2676
    @arupgope2676 6 месяцев назад

    your explanation is great. I have tried many dsa channels to follow. Then I find this channel. It is so great and underrated.

  • @nagendravelpuri444
    @nagendravelpuri444 Год назад

    For this problem i seen many videos, but this one was crystal clear and i never forget.
    Very Good Job Sir.

  • @nexonsensei3793
    @nexonsensei3793 8 месяцев назад

    I watched so many videos n i could not understand the problem , after watching your video i finally understood it🥺🔥 the visualisation helped alot to understand

  • @srikanthchebrolu1091
    @srikanthchebrolu1091 Год назад +5

    I'm fan of ur way of teaching
    I learnt trees because of u
    Hope you start dp playlist like trees
    please ♥️😇

  • @akashvijayasarathy6234
    @akashvijayasarathy6234 8 месяцев назад

    this is a gem of a video.

  • @nandinideshpande1467
    @nandinideshpande1467 4 месяца назад

    your explanation was very simple. made me understand the problem.

  • @chandankumar-ip5hf
    @chandankumar-ip5hf Месяц назад

    directly went into my head, able to write code after dry run explanation

  • @Iam_Srikanth_009
    @Iam_Srikanth_009 4 месяца назад

    It was really a clean and clear explanation ❤

  • @suyashrahatekar4964
    @suyashrahatekar4964 Год назад +2

    underrated channel

  • @surenderreddy6294
    @surenderreddy6294 5 месяцев назад

    fantastic brilliant,explanation sir,you deserve a lot

  • @ABDULKALAM-ig2dd
    @ABDULKALAM-ig2dd Год назад +2

    Sir I am big fan of your leetcode playlist, Regularly folllowing it ,Please continue doing more videos on leetcode ,Waiting for more Leetcode problems ❤

    • @nikoo28
      @nikoo28  Год назад +2

      i am adding more and more problems when I get time. Trying to cover important problems first :)

    • @ABDULKALAM-ig2dd
      @ABDULKALAM-ig2dd Год назад

      @@nikoo28 🤍

  • @JagadeeswarN-ur7of
    @JagadeeswarN-ur7of 6 дней назад

    Great Explanation..thanks!!

  • @satyam_28
    @satyam_28 10 месяцев назад

    Cool explanation bhai...and an advice...keep content concise and outro subtle

    • @nikoo28
      @nikoo28  9 месяцев назад

      i try my best, but everyone has their own learning pace. for quick learners, i have chapter markers for faster navigation 😄

  • @usmanrangrez-cd7zj
    @usmanrangrez-cd7zj Год назад +1

    class Solution {
    public:
    bool canJump(vector& nums) {
    int n=nums.size();
    int maxJump=0;
    for(int i=0;imaxJump)
    return false;
    maxJump = max(maxJump,i+nums[i]);
    if(i>=n-1)
    return true;
    }
    return false;
    }
    };

  • @arslanmuhammad4190
    @arslanmuhammad4190 Год назад +1

    Hi Sir, You are gem. I am learning from you a lot. Thanks, Sir for this Help.

    • @nikoo28
      @nikoo28  Год назад

      It's my pleasure

  • @ankitchaurasiya529
    @ankitchaurasiya529 6 месяцев назад

    Just Wow...
    I understand after watching first time this video.

  • @sravansunkara
    @sravansunkara 3 месяца назад

    Excellent solution

  • @abhyudaysingh3381
    @abhyudaysingh3381 4 месяца назад

    Best Explaination 👍

  • @shresthgupta2670
    @shresthgupta2670 День назад

    Thanks sir love your intuition building 😍

  • @kunalkheeva
    @kunalkheeva Год назад

    Dry run really helped! thanks a tonne!

  • @catsadogga1651
    @catsadogga1651 5 месяцев назад

    your explanation is super

  • @amitshukla2268
    @amitshukla2268 11 месяцев назад

    Very nice explanation, thanks, keep it up :)

  • @rambhaktuchihaobito7987
    @rambhaktuchihaobito7987 7 месяцев назад +1

    thank u sir ... for such a great explanation❣❣

  • @Ayushkumar-co9mc
    @Ayushkumar-co9mc 8 месяцев назад

    Best explanation ever

  • @gauravjain969
    @gauravjain969 Год назад

    Awesome explanation 🔥

  • @jamesk6884
    @jamesk6884 9 месяцев назад +1

    amazing explanation, love the video.
    this is my algorithm before watching ur video, it only passed 120/170 test cases when i tried to submit it. So i just wanted to know if my approach to this question is definitely incorrect.
    class Solution {
    public boolean canJump(int[] nums) {
    int size = nums.length-1;
    int sum = 0;
    for (int i=0; i < nums.length-1; i++){
    sum += nums[i];
    }
    if (sum-(nums.length-2)>= size){
    return true;
    } else if (nums[0]>= nums.length-1){
    return true;
    } else{
    return false;
    }
    }
    }
    again, thx for the video

  • @tejas5331
    @tejas5331 9 месяцев назад

    i like how you explain with Animation

  • @КарэнАкопьян
    @КарэнАкопьян Год назад

    Thank you for your work!

    • @nikoo28
      @nikoo28  11 месяцев назад

      My pleasure!

  • @tanishkaagarwal6750
    @tanishkaagarwal6750 Год назад

    sir your explaination is awesome... keep uploading more videos.

    • @nikoo28
      @nikoo28  Год назад

      thanks for your feedback, keep watching :)

  • @Paradox82827
    @Paradox82827 8 месяцев назад

    Very good explaination!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

  • @Karan9.9
    @Karan9.9 11 месяцев назад

    very nice and clear explanation thanks !!!

    • @nikoo28
      @nikoo28  11 месяцев назад

      Glad it was helpful!

  • @arjitgautam365
    @arjitgautam365 10 месяцев назад +1

    really helpful. Thanks a lot!

  • @sagniksaha4179
    @sagniksaha4179 2 месяца назад +1

    Explanation is awesome 💯. But i was thinking is it possible to think this soln in an interview. The very first thing came to my mind was recursion. I found this while i was going through the discussion section of leetcode. Any advices on how to think this type of soln in an interview. Any suggestion is appreciated

    • @philj9594
      @philj9594 3 дня назад

      The only real answer is to grind these problems over and over. Just like a math class, the best way to get good is extreme repetition of practice problems. Also, sometimes you just won't get the problem in your interview and you need to focus on the next one and realize that this is normal and to not be discouraged. If you do enough problems to where you can solve even 10% of them easily and quickly, then you are able to get a job if you just get lucky enough to have those 10% of problems in your interview.

  • @tamilansgame7306
    @tamilansgame7306 2 месяца назад

    perfect explantion

  • @MadpolygonDEV
    @MadpolygonDEV Год назад +2

    Incredible presentation as always. Would love to have you do a problem solving mindset tips and tricks.

    • @nikoo28
      @nikoo28  Год назад

      that is a really great idea, I will add it to my pipeline of upcoming videos

  • @jk-sm6qr
    @jk-sm6qr 7 месяцев назад

    Nice explaination, Thank you

    • @nikoo28
      @nikoo28  7 месяцев назад +1

      You are welcome

  • @LetsGo-ro1iq
    @LetsGo-ro1iq 7 месяцев назад +1

    Great Video

  • @КарэнАкопьян
    @КарэнАкопьян Год назад

    Thank you, you helped me so much!

    • @nikoo28
      @nikoo28  Год назад

      You're very welcome!

  • @bipinsingh1490
    @bipinsingh1490 Год назад

    Bhai quality explaintaion h apka great baki RUclips channel toh bs code padh dete h intuition toh batate v nhi h

    • @nikoo28
      @nikoo28  Год назад

      i like to focus on the problem solving, rather than the language. Languages will come and go. 😅, logic will stay

  • @shubhamkumar-hx1fb
    @shubhamkumar-hx1fb 10 месяцев назад

    i really hate kind of videos which doesnt tells the intuition why we are doing so.....there are many videos avl for this pblm and many of them are just doing the dry run of the code without telling the intuition behind their though process....
    But i am really thanks to you sir that you focused more on the intuition behind the code and have not just done the dry run 😌😌

    • @nikoo28
      @nikoo28  9 месяцев назад

      glad you liked it

  • @workHolic-ne6eo
    @workHolic-ne6eo Год назад

    thats the video i was searching exactly

  • @raghavachekuri7270
    @raghavachekuri7270 Год назад

    outstanding explination plz try to do playlist for DP ur explination is 🥳

    • @nikoo28
      @nikoo28  Год назад

      I have a playlist on DP. Constantly adding more and more problems to it: ruclips.net/p/PLFdAYMIVJQHPXtFM_9mpwwQtIdzP6kxHS

  • @amitshukla2268
    @amitshukla2268 11 месяцев назад +1

    Please add your chair also in your Recording Gear? Did you buy it from amazon ?

    • @nikoo28
      @nikoo28  11 месяцев назад

      Links in the description :)

    • @amitshukla2268
      @amitshukla2268 11 месяцев назад

      @@nikoo28 i didn't find it.

    • @nikoo28
      @nikoo28  9 месяцев назад

      Chair is from Autonomous.

  • @Krishnasagars22
    @Krishnasagars22 2 месяца назад

    Great!! Thanks a lot

  • @abhishekomprakash4074
    @abhishekomprakash4074 11 месяцев назад

    Super useful.💯

  • @Mr.NothingSpecial
    @Mr.NothingSpecial 9 месяцев назад

    You're basically looking for the last reachable index at each iteration. That is not a greedy approach. Can you explain what do you mean by greedy approach?

    • @nikoo28
      @nikoo28  9 месяцев назад

      My greed is that I want to reach the last pointer from where I am standing

  • @Shhhh-ni5jw
    @Shhhh-ni5jw 8 месяцев назад

    With this approach, we never stop on the 0’s right? We are checking if somehow we are able to bypass

  • @gurudassulebhavikar
    @gurudassulebhavikar 11 месяцев назад +1

    You could have used your Jump Game 2 solution here. Both problems are almost same.

  • @mahadishakkhor123
    @mahadishakkhor123 9 месяцев назад

    i understand from u

  • @taslimarahmanprema8643
    @taslimarahmanprema8643 11 месяцев назад +1

    Best one

  • @abhinavprasad2828
    @abhinavprasad2828 11 месяцев назад

    Okay so, I don't usually comment but yeah this video was great.

    • @nikoo28
      @nikoo28  11 месяцев назад

      Thank you so much

  • @MeghaVerma-n9k
    @MeghaVerma-n9k Месяц назад

    Osm explanation thnks

  • @paridhishrivastava9133
    @paridhishrivastava9133 Год назад

    thankyou so much sir its too good

  • @razataggarwal7365
    @razataggarwal7365 11 месяцев назад +3

    Why we are calling optimal solution as greedy algorithm ?
    My perspective :
    If I see it, we have optimized our Iterative DP (Tabulation) by going to every index from last to first and asking if i can reach target or not.

  • @murugesh1915
    @murugesh1915 5 месяцев назад

    Nice content

  • @saisree04
    @saisree04 6 месяцев назад

    Thanks a ton

  • @TraySoek
    @TraySoek Год назад +1

    brilliant

  • @subhashreesahoo5760
    @subhashreesahoo5760 6 месяцев назад

    Hi.. Thanks for the vide, your explanation is really good and helpful.
    But I do have doubt here and a request while explaining , pls consider the code also .
    I feel like the explanation and the dry run code somewhere I am unable to understabnd(may be I need more practice but still..)
    Example-> while explaining you said to go back step from 1 , that is 0, you cant reach the destination => agree
    but in dry run code-> idx+nums[idx] , how are you bringing these terms, like how did you think its should be in this way , its like idx=7,nums[7]=0 and you are adding both 7+0=7, so i am not getting how your idea is to add idx+nums[idex].

    • @nikoo28
      @nikoo28  6 месяцев назад

      If you have understood the explanation, try to write the code on your own. That is the only way you will learn. If everything else fails, only then refer to someone else’s code.

    • @subhashreesahoo5760
      @subhashreesahoo5760 6 месяцев назад

      @@nikoo28 ok sure, Thank you, I will take your advice and implement the same.

  • @filmbuzz9419
    @filmbuzz9419 Год назад

    Take a value and show it by dry run so we understand a bit more Thanks

  • @subee128
    @subee128 11 месяцев назад +1

    Thanks

  • @nguyenhoanthien4277
    @nguyenhoanthien4277 2 месяца назад

    great!

  • @hamdasalam4373
    @hamdasalam4373 4 месяца назад

    could you please create a video for leetcode 2483?

  • @nehakanki1606
    @nehakanki1606 9 месяцев назад

    Got itt👍

  • @SibiRanganathL
    @SibiRanganathL 2 месяца назад

    Understood

  • @AshishKumar-x5l8s
    @AshishKumar-x5l8s 9 месяцев назад

    Its O(N**2) ?? Can anyone explain in case of DP

    • @nikoo28
      @nikoo28  8 месяцев назад

      why do you want a solution with a poor time complexity?

  • @DigvijayKirti
    @DigvijayKirti 10 месяцев назад

    What if the second last element is zero?
    Let's dry run the provided array [3, 2, 1, 0, 4] through the given canJump method:
    Dry run:
    Initial State: lastElement = 4 (index of the last element).
    Iteration 1 (i = 3):
    i + nums[i] = 3 + 0 >= 4, which is less than lastElement. No update.
    Iteration 2 (i = 2):
    i + nums[i] = 2 + 1 >= 4, which is less than lastElement. No update
    Iteration 3 (i = 1):
    i + nums[i] = 1 + 2 >= 4, which is less than lastElement. No update
    Iteration 4 (i = 0):
    i + nums[i] = 0 + 3 >= 4, which is less than lastElement. No update
    Return: lastElement == 0, which is true.
    So, for the array [3, 2, 1, 0, 4], the canJump method returns true, indicating that it is possible to jump from the first element to the last element.
    Please explain I'm not able to understand the false case?

    • @nikoo28
      @nikoo28  9 месяцев назад

      you need to start from the last element, not the first one. watch the explanation that starts at 9:17

  • @pkeditsff8405
    @pkeditsff8405 22 дня назад

    I didn't understand your code 😢😢😢😢

    • @philj9594
      @philj9594 3 дня назад

      This problem is pretty advanced if you are relatively new to coding. I'm at the end of a college-level data structures course and they included this problem in the homework and the professor even admits that most people at our level will not be able to solve these leetcode 150 problems and he said you are on the right track if you can at least come up with an idea of how to solve the problems that he is giving us.
      My point is, if you are just completely lost, that just means you need to look at easier problems and work your way up to this. I promise you that this will make sense later on if you just don't give up. You need to be working at your current level. Even though I understand this code, there are many where I wouldn't understand just like you. Look up the "zone of proximal development" and try to find out where your zone currently is and just work within there. Your experience here is perfectly normal and expected. Don't be ashamed if you have to go back to the very basics of coding for awhile.

  • @singhvishal8794
    @singhvishal8794 9 месяцев назад +2

    i actually tried this code and come across a wrong ans for [1] as it is reachable at any cost so i run the loop from nums.length -1 to 0 and that worked.... and thank you for this amazing solution i stuck on this for 3 hrs straight...